
'''

# 

# Santa Lucia Model
https://www.geneseo.edu/~macula/Cou_F05/biomathF05/annurev.biophys.32.110601.141800.pdf


# Primer3 Example can be found in:
https://primer3.org/manual.html

'''


import pandas as pd
# import math
import numpy as np



def Thermodynamics(PlusSense,MinusSense):

	# Define ThermoDF
	ThermoDF = pd.DataFrame({'Pair One': {0: 'AA',
  1: 'TT',
  2: 'AT',
  3: 'AT',
  4: 'TA',
  5: 'TA',
  6: 'CA',
  7: 'TG',
  8: 'GT',
  9: 'AC',
  10: 'CT',
  11: 'AG',
  12: 'GA',
  13: 'TC',
  14: 'CG',
  15: 'CG',
  16: 'GC',
  17: 'GC',
  18: 'GG',
  19: 'CC',
  20: 'AA',
  21: 'AT',
  22: 'CA',
  23: 'AG',
  24: 'GA',
  25: 'AC',
  26: 'TA',
  27: 'AA',
  28: 'AC',
  29: 'CT',
  30: 'CC',
  31: 'CG',
  32: 'GC',
  33: 'CC',
  34: 'TC',
  35: 'CA',
  36: 'AG',
  37: 'GT',
  38: 'CG',
  39: 'GG',
  40: 'GG',
  41: 'GC',
  42: 'TG',
  43: 'GA',
  44: 'AT',
  45: 'TT',
  46: 'CT',
  47: 'TG',
  48: 'GT',
  49: 'TC',
  50: 'TT',
  51: 'TA',
  52: 'AG',
  53: 'TT',
  54: 'AT',
  55: 'GT',
  56: 'CG',
  57: 'TG',
  58: 'CT',
  59: 'GG',
  60: 'GG',
  61: 'TC',
  62: 'GG',
  63: 'TT',
  64: 'GT',
  65: 'GC',
  66: 'GT',
  67: 'GT',
  68: 'TG',
  69: 'TA',
  70: 'TG',
  71: 'TG',
  72: 'TT',
  73: 'GA',
  74: 'AA',
  75: 'CT',
  76: 'AC',
  77: 'AT',
  78: 'CA',
  79: 'CG',
  80: 'CC',
  81: 'AG',
  82: 'GA',
  83: 'CC',
  84: 'GC',
  85: 'AC',
  86: 'TA',
  87: 'CA',
  88: 'TC',
  89: 'AA',
  90: 'AA',
  91: 'GT',
  92: 'AG',
  93: 'AT',
  94: 'CA',
  95: 'GG',
  96: 'CG',
  97: 'AG',
  98: 'GA',
  99: 'GC',
  100: 'GG',
  101: 'AC',
  102: 'TA',
  103: 'GA',
  104: 'TG',
  105: 'AA',
  106: 'AC',
  107: 'TT',
  108: 'AT',
  109: 'CT',
  110: 'CC',
  111: 'TG',
  112: 'CT',
  113: 'CG',
  114: 'GC',
  115: 'TC',
  116: 'GT',
  117: 'CC',
  118: 'TC',
  119: 'TA',
  120: 'TT',
  121: 'CA',
  122: 'AA',
  123: 'TA',
  124: 'CA',
  125: 'GA',
  126: 'AC',
  127: 'TC',
  128: 'CC',
  129: 'GC',
  130: 'AG',
  131: 'TG',
  132: 'CG',
  133: 'GG',
  134: 'AT',
  135: 'TT',
  136: 'CT',
  137: 'GT',
  138: 'AA',
  139: 'AC',
  140: 'CA',
  141: 'CC',
  142: 'GA',
  143: 'GC',
  144: 'TA',
  145: 'TC',
  146: 'AC',
  147: 'AT',
  148: 'CC',
  149: 'CT',
  150: 'GC',
  151: 'GT',
  152: 'TC',
  153: 'TT',
  154: 'AA',
  155: 'AG',
  156: 'CA',
  157: 'CG',
  158: 'GA',
  159: 'GG',
  160: 'TA',
  161: 'TG',
  162: 'AG',
  163: 'AT',
  164: 'CG',
  165: 'CT',
  166: 'GG',
  167: 'GT',
  168: 'TG',
  169: 'TT'},
							 'Pair Two': {0: 'TT',
							  1: 'AA',
							  2: 'TA',
							  3: 'TA',
							  4: 'AT',
							  5: 'AT',
							  6: 'GT',
							  7: 'AC',
							  8: 'CA',
							  9: 'TG',
							  10: 'GA',
							  11: 'TC',
							  12: 'CT',
							  13: 'AG',
							  14: 'GC',
							  15: 'GC',
							  16: 'CG',
							  17: 'CG',
							  18: 'CC',
							  19: 'GG',
							  20: 'TA',
							  21: 'AA',
							  22: 'GA',
							  23: 'AC',
							  24: 'CA',
							  25: 'AG',
							  26: 'AA',
							  27: 'AT',
							  28: 'TC',
							  29: 'CA',
							  30: 'GC',
							  31: 'CC',
							  32: 'CC',
							  33: 'CG',
							  34: 'AC',
							  35: 'CT',
							  36: 'TG',
							  37: 'GA',
							  38: 'GG',
							  39: 'GC',
							  40: 'CG',
							  41: 'GG',
							  42: 'AG',
							  43: 'GT',
							  44: 'TT',
							  45: 'TA',
							  46: 'GT',
							  47: 'TC',
							  48: 'CT',
							  49: 'TG',
							  50: 'AT',
							  51: 'TT',
							  52: 'TT',
							  53: 'GA',
							  54: 'TG',
							  55: 'TA',
							  56: 'GT',
							  57: 'GC',
							  58: 'GG',
							  59: 'TC',
							  60: 'CT',
							  61: 'GG',
							  62: 'TT',
							  63: 'GG',
							  64: 'CG',
							  65: 'TG',
							  66: 'TG',
							  67: 'TG',
							  68: 'AT',
							  69: 'GT',
							  70: 'GT',
							  71: 'GT',
							  72: 'AG',
							  73: 'TT',
							  74: 'TC',
							  75: 'AA',
							  76: 'TA',
							  77: 'CA',
							  78: 'GC',
							  79: 'AC',
							  80: 'GA',
							  81: 'CC',
							  82: 'CC',
							  83: 'AG',
							  84: 'CA',
							  85: 'CG',
							  86: 'AC',
							  87: 'AT',
							  88: 'AA',
							  89: 'CT',
							  90: 'TG',
							  91: 'AA',
							  92: 'TA',
							  93: 'GA',
							  94: 'GG',
							  95: 'AC',
							  96: 'GA',
							  97: 'GC',
							  98: 'CG',
							  99: 'AG',
							  100: 'CA',
							  101: 'GG',
							  102: 'AG',
							  103: 'AT',
							  104: 'AA',
							  105: 'GT',
							  106: 'TT',
							  107: 'CA',
							  108: 'TC',
							  109: 'TA',
							  110: 'GT',
							  111: 'CC',
							  112: 'GC',
							  113: 'TC',
							  114: 'CT',
							  115: 'CG',
							  116: 'CC',
							  117: 'TG',
							  118: 'AT',
							  119: 'CT',
							  120: 'AC',
							  121: 'TT',
							  122: 'TA',
							  123: 'AA',
							  124: 'GA',
							  125: 'CA',
							  126: 'TC',
							  127: 'AC',
							  128: 'GC',
							  129: 'CC',
							  130: 'TG',
							  131: 'AG',
							  132: 'GG',
							  133: 'CG',
							  134: 'TT',
							  135: 'AT',
							  136: 'GT',
							  137: 'CT',
							  138: 'TC',
							  139: 'TA',
							  140: 'GC',
							  141: 'GA',
							  142: 'CC',
							  143: 'CA',
							  144: 'AC',
							  145: 'AA',
							  146: 'TT',
							  147: 'TC',
							  148: 'GT',
							  149: 'GC',
							  150: 'CT',
							  151: 'CC',
							  152: 'AT',
							  153: 'AC',
							  154: 'TG',
							  155: 'TA',
							  156: 'GG',
							  157: 'GA',
							  158: 'CG',
							  159: 'CA',
							  160: 'AG',
							  161: 'AA',
							  162: 'TT',
							  163: 'TG',
							  164: 'GT',
							  165: 'GG',
							  166: 'CT',
							  167: 'CG',
							  168: 'AT',
							  169: 'AG'},
							 'Delta H': {0: -7.6,
							  1: -7.6,
							  2: -7.2,
							  3: -7.2,
							  4: -7.2,
							  5: -7.2,
							  6: -8.5,
							  7: -8.5,
							  8: -8.4,
							  9: -8.4,
							  10: -7.8,
							  11: -7.8,
							  12: -8.2,
							  13: -8.2,
							  14: -10.6,
							  15: -10.6,
							  16: -9.8,
							  17: -9.8,
							  18: -8.0,
							  19: -8.0,
							  20: 1.2,
							  21: 1.2,
							  22: -0.9,
							  23: -0.9,
							  24: -2.9,
							  25: -2.9,
							  26: 4.7,
							  27: 4.7,
							  28: 0.0,
							  29: 0.0,
							  30: -1.5,
							  31: -1.5,
							  32: 3.6,
							  33: 3.6,
							  34: 6.1,
							  35: 6.1,
							  36: -3.1,
							  37: -3.1,
							  38: -4.9,
							  39: -4.9,
							  40: -6.0,
							  41: -6.0,
							  42: 1.6,
							  43: 1.6,
							  44: -2.7,
							  45: -2.7,
							  46: -5.0,
							  47: -5.0,
							  48: -2.2,
							  49: -2.2,
							  50: 0.2,
							  51: 0.2,
							  52: 1.0,
							  53: 1.0,
							  54: -2.5,
							  55: -2.5,
							  56: -4.1,
							  57: -4.1,
							  58: -2.8,
							  59: -2.8,
							  60: 3.3,
							  61: 3.3,
							  62: 5.8,
							  63: 5.8,
							  64: -4.4,
							  65: -4.4,
							  66: 4.1,
							  67: 4.1,
							  68: -0.1,
							  69: -0.1,
							  70: -1.4,
							  71: -1.4,
							  72: -1.3,
							  73: -1.3,
							  74: 2.3,
							  75: 2.3,
							  76: 5.3,
							  77: 5.3,
							  78: 1.9,
							  79: 1.9,
							  80: 0.6,
							  81: 0.6,
							  82: 5.2,
							  83: 5.2,
							  84: -0.7,
							  85: -0.7,
							  86: 3.4,
							  87: 3.4,
							  88: 7.6,
							  89: 7.6,
							  90: -0.6,
							  91: -0.6,
							  92: -0.7,
							  93: -0.7,
							  94: -0.7,
							  95: -0.7,
							  96: -4.0,
							  97: -4.0,
							  98: -0.6,
							  99: -0.6,
							  100: 0.5,
							  101: 0.5,
							  102: 0.7,
							  103: 0.7,
							  104: 3.0,
							  105: 3.0,
							  106: 0.7,
							  107: 0.7,
							  108: -1.2,
							  109: -1.2,
							  110: -0.8,
							  111: -0.8,
							  112: -1.5,
							  113: -1.5,
							  114: 2.3,
							  115: 2.3,
							  116: 5.2,
							  117: 5.2,
							  118: 1.2,
							  119: 1.2,
							  120: 1.0,
							  121: 1.0,
							  122: -3.1,
							  123: -2.5,
							  124: -4.3,
							  125: -8.0,
							  126: -0.1,
							  127: -0.7,
							  128: -2.1,
							  129: -3.9,
							  130: -1.1,
							  131: -1.1,
							  132: -3.8,
							  133: -0.7,
							  134: -2.4,
							  135: -3.2,
							  136: -6.1,
							  137: -7.4,
							  138: -1.6,
							  139: -1.8,
							  140: -2.6,
							  141: -2.7,
							  142: -5.0,
							  143: -3.2,
							  144: -2.3,
							  145: -2.7,
							  146: -0.9,
							  147: -2.3,
							  148: -3.2,
							  149: -3.9,
							  150: -4.9,
							  151: -3.0,
							  152: -2.5,
							  153: -0.7,
							  154: -1.9,
							  155: -2.5,
							  156: -3.9,
							  157: -6.0,
							  158: -4.3,
							  159: -4.6,
							  160: -2.0,
							  161: -2.4,
							  162: -3.2,
							  163: -3.5,
							  164: -3.8,
							  165: -6.6,
							  166: -5.7,
							  167: -5.9,
							  168: -3.9,
							  169: -3.6},
							 'Delta S': {0: -21.3,
							  1: -21.3,
							  2: -20.4,
							  3: -20.4,
							  4: -21.3,
							  5: -21.3,
							  6: -22.7,
							  7: -22.7,
							  8: -22.4,
							  9: -22.4,
							  10: -21.0,
							  11: -21.0,
							  12: -22.2,
							  13: -22.2,
							  14: -27.2,
							  15: -27.2,
							  16: -24.4,
							  17: -24.4,
							  18: -19.9,
							  19: -19.9,
							  20: 1.7,
							  21: 1.7,
							  22: -4.2,
							  23: -4.2,
							  24: -9.8,
							  25: -9.8,
							  26: 12.9,
							  27: 12.9,
							  28: -4.4,
							  29: -4.4,
							  30: -7.2,
							  31: -7.2,
							  32: 8.9,
							  33: 8.9,
							  34: 16.4,
							  35: 16.4,
							  36: -9.5,
							  37: -9.5,
							  38: -15.3,
							  39: -15.3,
							  40: -15.8,
							  41: -15.8,
							  42: 3.6,
							  43: 3.6,
							  44: -10.8,
							  45: -10.8,
							  46: -15.8,
							  47: -15.8,
							  48: -8.4,
							  49: -8.4,
							  50: -1.5,
							  51: -1.5,
							  52: 0.9,
							  53: 0.9,
							  54: -8.3,
							  55: -8.3,
							  56: -11.7,
							  57: -11.7,
							  58: -8.0,
							  59: -8.0,
							  60: 10.4,
							  61: 10.4,
							  62: 16.3,
							  63: 16.3,
							  64: -12.3,
							  65: -12.3,
							  66: 9.5,
							  67: 9.5,
							  68: -1.7,
							  69: -1.7,
							  70: -6.2,
							  71: -6.2,
							  72: -5.3,
							  73: -5.3,
							  74: 4.6,
							  75: 4.6,
							  76: 14.6,
							  77: 14.6,
							  78: 3.7,
							  79: 3.7,
							  80: -0.6,
							  81: -0.6,
							  82: 14.2,
							  83: 14.2,
							  84: -3.8,
							  85: -3.8,
							  86: 8.0,
							  87: 8.0,
							  88: 20.2,
							  89: 20.2,
							  90: -2.3,
							  91: -2.3,
							  92: -2.3,
							  93: -2.3,
							  94: -2.3,
							  95: -2.3,
							  96: -13.2,
							  97: -13.2,
							  98: -1.0,
							  99: -1.0,
							  100: 3.2,
							  101: 3.2,
							  102: 0.7,
							  103: 0.7,
							  104: 7.4,
							  105: 7.4,
							  106: 0.2,
							  107: 0.2,
							  108: -6.2,
							  109: -6.2,
							  110: -4.5,
							  111: -4.5,
							  112: -6.1,
							  113: -6.1,
							  114: 5.4,
							  115: 5.4,
							  116: 13.5,
							  117: 13.5,
							  118: 0.7,
							  119: 0.7,
							  120: 0.7,
							  121: 0.7,
							  122: -7.8,
							  123: -6.3,
							  124: -10.7,
							  125: -22.5,
							  126: 0.5,
							  127: -1.3,
							  128: -5.1,
							  129: -10.6,
							  130: -2.1,
							  131: -2.7,
							  132: -9.5,
							  133: -19.2,
							  134: -6.5,
							  135: -8.9,
							  136: -16.9,
							  137: -21.2,
							  138: -4.0,
							  139: -3.8,
							  140: -5.9,
							  141: -6.0,
							  142: -13.8,
							  143: -7.1,
							  144: -5.9,
							  145: -7.0,
							  146: -1.7,
							  147: -6.3,
							  148: -8.0,
							  149: -10.6,
							  150: -13.5,
							  151: -7.8,
							  152: -6.3,
							  153: -1.2,
							  154: -4.4,
							  155: -5.9,
							  156: -9.6,
							  157: -15.5,
							  158: -11.1,
							  159: -11.4,
							  160: -4.7,
							  161: -5.8,
							  162: -8.7,
							  163: -9.4,
							  164: -9.0,
							  165: -18.7,
							  166: -15.9,
							  167: -16.1,
							  168: -10.5,
							  169: -9.8},
							 'Gibbs free energy': {0: -1.0,
							  1: -1.0,
							  2: -0.88,
							  3: -0.88,
							  4: -0.58,
							  5: -0.58,
							  6: -1.45,
							  7: -1.45,
							  8: -1.44,
							  9: -1.44,
							  10: -1.28,
							  11: -1.28,
							  12: -1.3,
							  13: -1.3,
							  14: -2.17,
							  15: -2.17,
							  16: -2.24,
							  17: -2.24,
							  18: -1.84,
							  19: -1.84,
							  20: 0.61,
							  21: 0.61,
							  22: 0.43,
							  23: 0.43,
							  24: 0.17,
							  25: 0.17,
							  26: 0.69,
							  27: 0.69,
							  28: 1.33,
							  29: 1.33,
							  30: 0.7,
							  31: 0.7,
							  32: 0.79,
							  33: 0.79,
							  34: 1.05,
							  35: 1.05,
							  36: -0.13,
							  37: -0.13,
							  38: -0.11,
							  39: -0.11,
							  40: -1.11,
							  41: -1.11,
							  42: 0.44,
							  43: 0.44,
							  44: 0.69,
							  45: 0.69,
							  46: -0.12,
							  47: -0.12,
							  48: 0.45,
							  49: 0.45,
							  50: 0.68,
							  51: 0.68,
							  52: 0.71,
							  53: 0.71,
							  54: 0.07,
							  55: 0.07,
							  56: -0.47,
							  57: -0.47,
							  58: -0.32,
							  59: -0.32,
							  60: 0.08,
							  61: 0.08,
							  62: 0.74,
							  63: 0.74,
							  64: -0.59,
							  65: -0.59,
							  66: 1.15,
							  67: 1.15,
							  68: 0.43,
							  69: 0.43,
							  70: 0.52,
							  71: 0.52,
							  72: 0.34,
							  73: 0.34,
							  74: 0.88,
							  75: 0.88,
							  76: 0.77,
							  77: 0.77,
							  78: 0.75,
							  79: 0.75,
							  80: 0.79,
							  81: 0.79,
							  82: 0.81,
							  83: 0.81,
							  84: 0.47,
							  85: 0.47,
							  86: 0.92,
							  87: 0.92,
							  88: 1.33,
							  89: 1.33,
							  90: 0.14,
							  91: 0.14,
							  92: 0.02,
							  93: 0.02,
							  94: 0.03,
							  95: 0.03,
							  96: 0.11,
							  97: 0.11,
							  98: -0.25,
							  99: -0.25,
							  100: -0.52,
							  101: -0.52,
							  102: 0.42,
							  103: 0.42,
							  104: 0.74,
							  105: 0.74,
							  106: 0.64,
							  107: 0.64,
							  108: 0.73,
							  109: 0.73,
							  110: 0.62,
							  111: 0.62,
							  112: 0.4,
							  113: 0.4,
							  114: 0.62,
							  115: 0.62,
							  116: 0.98,
							  117: 0.98,
							  118: 0.97,
							  119: 0.97,
							  120: 0.75,
							  121: 0.75,
							  122: -0.67,
							  123: -0.58,
							  124: -1.01,
							  125: -0.99,
							  126: -0.21,
							  127: -0.29,
							  128: -0.52,
							  129: -0.62,
							  130: -0.42,
							  131: -0.29,
							  132: -0.83,
							  133: -0.96,
							  134: -0.45,
							  135: -0.48,
							  136: -0.87,
							  137: -0.86,
							  138: -0.35,
							  139: -0.59,
							  140: -0.76,
							  141: -0.85,
							  142: -0.71,
							  143: -1.01,
							  144: -0.45,
							  145: -0.55,
							  146: -0.33,
							  147: -0.35,
							  148: -0.69,
							  149: -0.6,
							  150: -0.72,
							  151: -0.61,
							  152: -0.52,
							  153: -0.34,
							  154: -0.52,
							  155: -0.65,
							  156: -0.88,
							  157: -1.23,
							  158: -0.8,
							  159: -1.08,
							  160: -0.53,
							  161: -0.57,
							  162: -0.45,
							  163: -0.54,
							  164: -0.96,
							  165: -0.81,
							  166: -0.76,
							  167: -0.92,
							  168: -0.59,
							  169: -0.59},
							 'TYPE': {0: 'PM',
							  1: 'PM',
							  2: 'PM',
							  3: 'PM',
							  4: 'PM',
							  5: 'PM',
							  6: 'PM',
							  7: 'PM',
							  8: 'PM',
							  9: 'PM',
							  10: 'PM',
							  11: 'PM',
							  12: 'PM',
							  13: 'PM',
							  14: 'PM',
							  15: 'PM',
							  16: 'PM',
							  17: 'PM',
							  18: 'PM',
							  19: 'PM',
							  20: 'Internal_MM',
							  21: 'Internal_MM',
							  22: 'Internal_MM',
							  23: 'Internal_MM',
							  24: 'Internal_MM',
							  25: 'Internal_MM',
							  26: 'Internal_MM',
							  27: 'Internal_MM',
							  28: 'Internal_MM',
							  29: 'Internal_MM',
							  30: 'Internal_MM',
							  31: 'Internal_MM',
							  32: 'Internal_MM',
							  33: 'Internal_MM',
							  34: 'Internal_MM',
							  35: 'Internal_MM',
							  36: 'Internal_MM',
							  37: 'Internal_MM',
							  38: 'Internal_MM',
							  39: 'Internal_MM',
							  40: 'Internal_MM',
							  41: 'Internal_MM',
							  42: 'Internal_MM',
							  43: 'Internal_MM',
							  44: 'Internal_MM',
							  45: 'Internal_MM',
							  46: 'Internal_MM',
							  47: 'Internal_MM',
							  48: 'Internal_MM',
							  49: 'Internal_MM',
							  50: 'Internal_MM',
							  51: 'Internal_MM',
							  52: 'Internal_MM',
							  53: 'Internal_MM',
							  54: 'Internal_MM',
							  55: 'Internal_MM',
							  56: 'Internal_MM',
							  57: 'Internal_MM',
							  58: 'Internal_MM',
							  59: 'Internal_MM',
							  60: 'Internal_MM',
							  61: 'Internal_MM',
							  62: 'Internal_MM',
							  63: 'Internal_MM',
							  64: 'Internal_MM',
							  65: 'Internal_MM',
							  66: 'Internal_MM',
							  67: 'Internal_MM',
							  68: 'Internal_MM',
							  69: 'Internal_MM',
							  70: 'Internal_MM',
							  71: 'Internal_MM',
							  72: 'Internal_MM',
							  73: 'Internal_MM',
							  74: 'Internal_MM',
							  75: 'Internal_MM',
							  76: 'Internal_MM',
							  77: 'Internal_MM',
							  78: 'Internal_MM',
							  79: 'Internal_MM',
							  80: 'Internal_MM',
							  81: 'Internal_MM',
							  82: 'Internal_MM',
							  83: 'Internal_MM',
							  84: 'Internal_MM',
							  85: 'Internal_MM',
							  86: 'Internal_MM',
							  87: 'Internal_MM',
							  88: 'Internal_MM',
							  89: 'Internal_MM',
							  90: 'Internal_MM',
							  91: 'Internal_MM',
							  92: 'Internal_MM',
							  93: 'Internal_MM',
							  94: 'Internal_MM',
							  95: 'Internal_MM',
							  96: 'Internal_MM',
							  97: 'Internal_MM',
							  98: 'Internal_MM',
							  99: 'Internal_MM',
							  100: 'Internal_MM',
							  101: 'Internal_MM',
							  102: 'Internal_MM',
							  103: 'Internal_MM',
							  104: 'Internal_MM',
							  105: 'Internal_MM',
							  106: 'Internal_MM',
							  107: 'Internal_MM',
							  108: 'Internal_MM',
							  109: 'Internal_MM',
							  110: 'Internal_MM',
							  111: 'Internal_MM',
							  112: 'Internal_MM',
							  113: 'Internal_MM',
							  114: 'Internal_MM',
							  115: 'Internal_MM',
							  116: 'Internal_MM',
							  117: 'Internal_MM',
							  118: 'Internal_MM',
							  119: 'Internal_MM',
							  120: 'Internal_MM',
							  121: 'Internal_MM',
							  122: 'Terminal_MM',
							  123: 'Terminal_MM',
							  124: 'Terminal_MM',
							  125: 'Terminal_MM',
							  126: 'Terminal_MM',
							  127: 'Terminal_MM',
							  128: 'Terminal_MM',
							  129: 'Terminal_MM',
							  130: 'Terminal_MM',
							  131: 'Terminal_MM',
							  132: 'Terminal_MM',
							  133: 'Terminal_MM',
							  134: 'Terminal_MM',
							  135: 'Terminal_MM',
							  136: 'Terminal_MM',
							  137: 'Terminal_MM',
							  138: 'Terminal_MM',
							  139: 'Terminal_MM',
							  140: 'Terminal_MM',
							  141: 'Terminal_MM',
							  142: 'Terminal_MM',
							  143: 'Terminal_MM',
							  144: 'Terminal_MM',
							  145: 'Terminal_MM',
							  146: 'Terminal_MM',
							  147: 'Terminal_MM',
							  148: 'Terminal_MM',
							  149: 'Terminal_MM',
							  150: 'Terminal_MM',
							  151: 'Terminal_MM',
							  152: 'Terminal_MM',
							  153: 'Terminal_MM',
							  154: 'Terminal_MM',
							  155: 'Terminal_MM',
							  156: 'Terminal_MM',
							  157: 'Terminal_MM',
							  158: 'Terminal_MM',
							  159: 'Terminal_MM',
							  160: 'Terminal_MM',
							  161: 'Terminal_MM',
							  162: 'Terminal_MM',
							  163: 'Terminal_MM',
							  164: 'Terminal_MM',
							  165: 'Terminal_MM',
							  166: 'Terminal_MM',
							  167: 'Terminal_MM',
							  168: 'Terminal_MM',
							  169: 'Terminal_MM'}})





	# Define Dictionary
	OutputDict = {'Gibbs':1.96,
				  'Entropy':-5.7,
				  'Enthalpy':0.2,
				  'Gibbs5P':1.96,
				  'Gibbs3P':1.96}


	GibbsFreeEnergyInput = list(zip([PlusSense[i:i+2] for i in list(range(len(PlusSense)-1))],
									[MinusSense[i:i+2] for i in list(range(len(MinusSense)-1))]))


	# Iterate through Nearest-Neighbour paired nucleotides apart from terminal.
	# this is using the standard ThermoDF which contains perfect matches
	# and internal mismatches.
	MissingPair = False
	for NNpair in GibbsFreeEnergyInput[:-1]:
		try:
			RowOfInterestIndex = ThermoDF[(ThermoDF['Pair One']==NNpair[0])&(ThermoDF['Pair Two']==NNpair[1])&(ThermoDF['TYPE'].isin(['PM','Internal_MM']))].index.tolist()[0]
		except:
			print(NNpair)
			MissingPair = True

		# If Nearest-Neighbour pair valid update thermodynamic scores.
		if MissingPair == False:
			#print(ThermoDF.loc[RowOfInterestIndex,:])
			OutputDict['Gibbs'] += ThermoDF.loc[RowOfInterestIndex,'Gibbs free energy']
			OutputDict['Enthalpy'] += ThermoDF.loc[RowOfInterestIndex,'Delta H']
			OutputDict['Entropy'] += ThermoDF.loc[RowOfInterestIndex,'Delta S']


	# Now test terminal nucleotide pair. This is basically terminal mismatch pairs
	# or perfect match pairs.
	TermNNPair=GibbsFreeEnergyInput[-1]

	CompDict = {'A':'T',
				'T':'A',
				'G':'C',
				'C':'G'}

	if CompDict[TermNNPair[0][1]] != TermNNPair[1][1]:
		CHAR = ['Terminal_MM']
	else:
		CHAR = ['PM','Internal_MM']

	try:
		TTII = ThermoDF[(ThermoDF['Pair One']==TermNNPair[0])&(ThermoDF['Pair Two']==TermNNPair[1])&(ThermoDF['TYPE'].isin(CHAR))].index.tolist()[0]
	except:
		MissingPair = True

	# If Nearest-Neighbour pair valid update thermodynamic scores.
	if MissingPair == False:
		#print(TermThermoDF.loc[TTII,:])
		OutputDict['Gibbs'] += ThermoDF.loc[TTII,'Gibbs free energy']
		OutputDict['Enthalpy'] += ThermoDF.loc[TTII,'Delta H']
		OutputDict['Entropy'] += ThermoDF.loc[TTII,'Delta S']


	# If NN pair not found, return function early.
	# and generate necessary error message.
	if MissingPair == True:
		return ('Fail NN Pair not Found')


	# Derive terminal gibbs free energy values
	FivePrime = True
	for TerminalPairs in [GibbsFreeEnergyInput[:6],
						GibbsFreeEnergyInput[-6:]]:

		for PLNN in TerminalPairs:
			try:
				II = ThermoDF[(ThermoDF['Pair One']==PLNN[0])&
							(ThermoDF['Pair Two']==PLNN[1])].index.tolist()[0]
			except:
				II = ThermoDF[(ThermoDF['Pair One']==PLNN[1][::-1])&
							(ThermoDF['Pair Two']==PLNN[0][::-1])].index.tolist()[0]


			if FivePrime == True:
				OutputDict['Gibbs5P'] += ThermoDF.loc[II,'Gibbs free energy']
			else:
				OutputDict['Gibbs3P'] += ThermoDF.loc[II,'Gibbs free energy']

		FivePrime = False


	# Apply AT penality if necessary.
	FivePrime = True
	for terminal in [''.join([PlusSense[0],MinusSense[0]]),
					''.join([PlusSense[-1],MinusSense[-1]])]:

		if terminal in ['AT','TA']:


			OutputDict['Gibbs'] += 0.05
			OutputDict['Enthalpy'] += 2.2
			OutputDict['Entropy'] +=  6.9

			if FivePrime == True:
				OutputDict['Gibbs5P'] += 0.05
				FivePrime = False
			else:
				OutputDict['Gibbs3P'] += 0.05

	return OutputDict


# Given Thermodynamics dictionary derive the Tm according to John
# Santa Lucia.

def Tm(Oligo,ThermoDict,TmVar):

	# print("Oligo:", Oligo)
	# print("ThermoDict:", ThermoDict)
	# print("TmVar:", TmVar)
	# print("Type of ThermoDict:", type(ThermoDict))

	# Calculate Salt Molarity for penalisation
	if TmVar.DivalentSaltConc >  TmVar.dNTPConc:
		SaltConc = (TmVar.MonovalentSaltConc + (120*((TmVar.DivalentSaltConc-TmVar.dNTPConc)**0.5))) * 10**-3
	else:
		SaltConc = TmVar.MonovalentSaltConc * 10**-3


	# Add in Salt Adjustment
	PhosphatesPresent = (len(Oligo)*2)-2
	# print('========================')
	ThermoDict['Adjusted Gibbs'] =  ThermoDict['Gibbs'] + (-0.114 * (PhosphatesPresent/2) * np.log(SaltConc))
	ThermoDict['Adjusted Entropy'] = ThermoDict['Entropy'] + (0.368 * (PhosphatesPresent/2) * np.log(SaltConc))


	# Determine Melting Temperature
	R=1.9872
	MeltingTemp = (ThermoDict['Enthalpy']*1000)/(ThermoDict['Adjusted Entropy']+(R*np.log((TmVar.OligoConc*10**-6)/4)))-273.15

	return (ThermoDict,MeltingTemp)


################################################################################
################################################################################
################################################################################
################################################################################


# class TmVar:
# 	DivalentSaltConc = 2
# 	MonovalentSaltConc = 10
# 	dNTPConc = 0.2
# 	OligoConc = 0.5
 
# TmVar = {
#     'DivalentSaltConc': 2,
#     'MonovalentSaltConc': 10,
#     'dNTPConc': 0.2,
#     'OligoConc': 0.5
# }


def simplified_tm(seq1, seq2, TmVar):
	thermo_dict = Thermodynamics(seq1,seq2)
	# print("thermo_dict:", thermo_dict)
	out = Tm(seq1, thermo_dict, TmVar)
	return(out)
